/* Software License Agreement (BSD License)
 *
 * Copyright (c) 2011, Willow Garage, Inc.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 *
 *  * Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 *  * Redistributions in binary form must reproduce the above
 *    copyright notice, this list of conditions and the following
 *    disclaimer in the documentation and/or other materials provided
 *    with the distribution.
 *  * Neither the name of Willow Garage, Inc. nor the names of its
 *    contributors may be used to endorse or promote products derived
 *    from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
 * "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
 * LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
 * FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE
 * COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
 * LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
 * CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN
 * ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
 * POSSIBILITY OF SUCH DAMAGE.
 *
 * Auto-generated by genmsg_cpp from file /local/robotpkg/var/tmp/robotpkg/motion/nhfc-genom3/work/templates/ros/client/ros/nhfc/msg/or_rotorcraft_rotor_state.msg
 *
 */


#ifndef NHFC_MESSAGE_OR_ROTORCRAFT_ROTOR_STATE_H
#define NHFC_MESSAGE_OR_ROTORCRAFT_ROTOR_STATE_H


#include <string>
#include <vector>
#include <map>

#include <ros/types.h>
#include <ros/serialization.h>
#include <ros/builtin_message_traits.h>
#include <ros/message_operations.h>

#include <nhfc/or_time_ts.h>

namespace nhfc
{
template <class ContainerAllocator>
struct or_rotorcraft_rotor_state_
{
  typedef or_rotorcraft_rotor_state_<ContainerAllocator> Type;

  or_rotorcraft_rotor_state_()
    : ts()
    , emerg(false)
    , spinning(false)
    , starting(false)
    , disabled(false)
    , velocity(0.0)
    , throttle(0.0)
    , consumption(0.0)
    , energy_level(0.0)  {
    }
  or_rotorcraft_rotor_state_(const ContainerAllocator& _alloc)
    : ts(_alloc)
    , emerg(false)
    , spinning(false)
    , starting(false)
    , disabled(false)
    , velocity(0.0)
    , throttle(0.0)
    , consumption(0.0)
    , energy_level(0.0)  {
    }



   typedef  ::nhfc::or_time_ts_<ContainerAllocator>  _ts_type;
  _ts_type ts;

   typedef uint8_t _emerg_type;
  _emerg_type emerg;

   typedef uint8_t _spinning_type;
  _spinning_type spinning;

   typedef uint8_t _starting_type;
  _starting_type starting;

   typedef uint8_t _disabled_type;
  _disabled_type disabled;

   typedef double _velocity_type;
  _velocity_type velocity;

   typedef double _throttle_type;
  _throttle_type throttle;

   typedef double _consumption_type;
  _consumption_type consumption;

   typedef double _energy_level_type;
  _energy_level_type energy_level;




  typedef boost::shared_ptr< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> > Ptr;
  typedef boost::shared_ptr< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> const> ConstPtr;

}; // struct or_rotorcraft_rotor_state_

typedef ::nhfc::or_rotorcraft_rotor_state_<std::allocator<void> > or_rotorcraft_rotor_state;

typedef boost::shared_ptr< ::nhfc::or_rotorcraft_rotor_state > or_rotorcraft_rotor_statePtr;
typedef boost::shared_ptr< ::nhfc::or_rotorcraft_rotor_state const> or_rotorcraft_rotor_stateConstPtr;

// constants requiring out of line definition



template<typename ContainerAllocator>
std::ostream& operator<<(std::ostream& s, const ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> & v)
{
ros::message_operations::Printer< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> >::stream(s, "", v);
return s;
}

} // namespace nhfc

namespace ros
{
namespace message_traits
{



// BOOLTRAITS {'IsFixedSize': True, 'IsMessage': True, 'HasHeader': False}
// {'actionlib_msgs': ['/opt/openrobots/share/actionlib_msgs/msg'], 'std_msgs': ['/opt/openrobots/share/std_msgs/msg'], 'nhfc': ['nhfc/msg']}

// !!!!!!!!!!! ['__class__', '__delattr__', '__dict__', '__doc__', '__eq__', '__format__', '__getattribute__', '__hash__', '__init__', '__module__', '__ne__', '__new__', '__reduce__', '__reduce_ex__', '__repr__', '__setattr__', '__sizeof__', '__str__', '__subclasshook__', '__weakref__', '_parsed_fields', 'constants', 'fields', 'full_name', 'has_header', 'header_present', 'names', 'package', 'parsed_fields', 'short_name', 'text', 'types']




template <class ContainerAllocator>
struct IsFixedSize< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsFixedSize< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> >
  : TrueType
  { };

template <class ContainerAllocator>
struct IsMessage< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> const>
  : TrueType
  { };

template <class ContainerAllocator>
struct HasHeader< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> >
  : FalseType
  { };

template <class ContainerAllocator>
struct HasHeader< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> const>
  : FalseType
  { };


template<class ContainerAllocator>
struct MD5Sum< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> >
{
  static const char* value()
  {
    return "a6e8f4bd0814d052b246845578a7fa0c";
  }

  static const char* value(const ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator>&) { return value(); }
  static const uint64_t static_value1 = 0xa6e8f4bd0814d052ULL;
  static const uint64_t static_value2 = 0xb246845578a7fa0cULL;
};

template<class ContainerAllocator>
struct DataType< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> >
{
  static const char* value()
  {
    return "nhfc/or_rotorcraft_rotor_state";
  }

  static const char* value(const ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator>&) { return value(); }
};

template<class ContainerAllocator>
struct Definition< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> >
{
  static const char* value()
  {
    return "# IDL struct ::or_rotorcraft::rotor_state\n\
or_time_ts ts\n\
bool emerg\n\
bool spinning\n\
bool starting\n\
bool disabled\n\
float64 velocity\n\
float64 throttle\n\
float64 consumption\n\
float64 energy_level\n\
\n\
================================================================================\n\
MSG: nhfc/or_time_ts\n\
# IDL struct ::or::time::ts\n\
uint32 sec\n\
uint32 nsec\n\
";
  }

  static const char* value(const ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator>&) { return value(); }
};

} // namespace message_traits
} // namespace ros

namespace ros
{
namespace serialization
{

  template<class ContainerAllocator> struct Serializer< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> >
  {
    template<typename Stream, typename T> inline static void allInOne(Stream& stream, T m)
    {
      stream.next(m.ts);
      stream.next(m.emerg);
      stream.next(m.spinning);
      stream.next(m.starting);
      stream.next(m.disabled);
      stream.next(m.velocity);
      stream.next(m.throttle);
      stream.next(m.consumption);
      stream.next(m.energy_level);
    }

    ROS_DECLARE_ALLINONE_SERIALIZER;
  }; // struct or_rotorcraft_rotor_state_

} // namespace serialization
} // namespace ros

namespace ros
{
namespace message_operations
{

template<class ContainerAllocator>
struct Printer< ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator> >
{
  template<typename Stream> static void stream(Stream& s, const std::string& indent, const ::nhfc::or_rotorcraft_rotor_state_<ContainerAllocator>& v)
  {
    s << indent << "ts: ";
    s << std::endl;
    Printer< ::nhfc::or_time_ts_<ContainerAllocator> >::stream(s, indent + "  ", v.ts);
    s << indent << "emerg: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.emerg);
    s << indent << "spinning: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.spinning);
    s << indent << "starting: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.starting);
    s << indent << "disabled: ";
    Printer<uint8_t>::stream(s, indent + "  ", v.disabled);
    s << indent << "velocity: ";
    Printer<double>::stream(s, indent + "  ", v.velocity);
    s << indent << "throttle: ";
    Printer<double>::stream(s, indent + "  ", v.throttle);
    s << indent << "consumption: ";
    Printer<double>::stream(s, indent + "  ", v.consumption);
    s << indent << "energy_level: ";
    Printer<double>::stream(s, indent + "  ", v.energy_level);
  }
};

} // namespace message_operations
} // namespace ros

#endif // NHFC_MESSAGE_OR_ROTORCRAFT_ROTOR_STATE_H
